﻿Imports System.Threading
Imports System.Runtime.InteropServices

Public Class Form1
  <DllImport("User32", CharSet:=CharSet.Auto, ExactSpelling:=True)> _
  Public Shared Function SetParent(ByVal hWndChild As IntPtr, ByVal hWndParent As IntPtr) As IntPtr
  End Function

  Dim frm2 As Windows.Forms.Form
  Dim NUI As UIThreading '(Me)
  Event DisposeForm()
  Event Navigate(ByVal URL As String)
  Event CloseForm()
  Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

    If NUI IsNot Nothing Then
      RaiseEvent CloseForm()
      NUI.releaseEvents()
      NUI = Nothing
    End If

    NUI = New UIThreading(Me)

    Dim thread As New Threading.Thread(AddressOf NUI.createConrol)
    thread.SetApartmentState(ApartmentState.STA)
    'AddHandler NUI.CntReady, AddressOf InvokeCntReady
    AddHandler NUI.handleReady, AddressOf InvokeHandleReady
    thread.Start()

  End Sub
  Sub HandleReady(ByVal h As Windows.Forms.Form)
    Me.frm2 = h
  End Sub
  Private Delegate Sub DelegateHandleReady(ByVal h As Windows.Forms.Form)
  Public Sub InvokeHandleReady(ByVal h As Windows.Forms.Form)

    If Me.InvokeRequired Then
      Dim args As Object() = {h}
      Dim Delegate_HandleReady As DelegateHandleReady = AddressOf InvokeHandleReady
      Me.Invoke(Delegate_HandleReady, args)
    Else
      HandleReady(h)
    End If
  End Sub

  'Private Sub cntReady(ByVal wb As Control)
  '  TabControl1.TabPages(0).Controls.Add(wb)
  'End Sub
  'Private Delegate Sub DelegatewebReady(ByVal wb As Control)
  'Public Sub InvokeCntReady(ByVal wb As Control)
  '  ' Call This
  '  If Me.InvokeRequired Then
  '    Dim args As Object() = {wb}
  '    Dim Delegate_cntReady As DelegatewebReady = AddressOf InvokeCntReady
  '    Me.Invoke(Delegate_cntReady, args)
  '  Else
  '    cntReady(wb)
  '  End If
  'End Sub

  Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
    RaiseEvent DisposeForm()
  End Sub

  Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
    RaiseEvent Navigate("http://yandex.ru")
  End Sub

  Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    RaiseEvent CloseForm()
  End Sub

  Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
    SetParent(frm2.Handle, Panel1.Handle)
  End Sub
End Class
