﻿Public Class UIThreading
  Property dl As Form2
  Event CntReady(ByVal wb As Control)
  Event handleReady(ByVal h As Windows.Forms.Form)
  Dim ff As Form1

  Sub New(ByVal f As Form1)
    Me.ff = f
  End Sub
  Sub createConrol()
    AddHandler Me.ff.DisposeForm, AddressOf InvokedisposeForm
    AddHandler Me.ff.Navigate, AddressOf InvokeNavigate
    AddHandler Me.ff.CloseForm, AddressOf InvokeCloseForm
    dl = New Form2
    AddHandler dl.Showed, AddressOf FormShowed
    dl.showDialog()
  End Sub
  Sub releaseEvents()
    RemoveHandler Me.ff.DisposeForm, AddressOf InvokedisposeForm
    RemoveHandler Me.ff.Navigate, AddressOf InvokeNavigate
    RemoveHandler Me.ff.CloseForm, AddressOf InvokeCloseForm
  End Sub
  Sub FormShowed()
    'Threading.Thread.Sleep(500)
    RaiseEvent handleReady(dl)
  End Sub

#Region "Invoks"
  Sub disposeForm()
    dl.Dispose()
  End Sub
  Private Delegate Sub DelegatedisposeForm()
  Public Sub InvokedisposeForm()
    If dl.InvokeRequired Then
      Dim args As Object() = {}
      Dim Delegate_disposeForm As DelegatedisposeForm = AddressOf InvokedisposeForm
      dl.Invoke(Delegate_disposeForm, args)
    Else
      disposeForm()
    End If
  End Sub
  '------------------------------
  Sub CloseForm()
    Try
      dl.Close()
    Catch ex As Exception

    End Try

  End Sub
  Private Delegate Sub DelegateCloseForm()
  Public Sub InvokeCloseForm()
    If dl.InvokeRequired Then
      Dim args As Object() = {}
      Dim Delegate_CloseForm As DelegateCloseForm = AddressOf InvokeCloseForm
      dl.Invoke(Delegate_CloseForm, args)
    Else
      CloseForm()
    End If
  End Sub
  '------------------------------
  Sub Navigate(ByVal Url As String)
    dl.WebBrowser1.Navigate(Url)
  End Sub
  Private Delegate Sub DelegateNavigate(ByVal Url As String)
  Public Sub InvokeNavigate(ByVal Url As String)
    If dl.InvokeRequired Then
      Dim args As Object() = {Url}
      Dim Delegate_Navigate As DelegateNavigate = AddressOf InvokeNavigate
      dl.Invoke(Delegate_Navigate, args)
    Else
      Navigate(Url)
    End If
  End Sub
#End Region
End Class